=== modified file 'TODO'
--- TODO	2008-08-02 14:33:47 +0000
+++ TODO	2008-07-29 03:35:39 +0000
@@ -1,35 +1,33 @@
--*- org -*-
-
-* Mandos client
-** header files/symbols tally
-** check exit codes of all system calls
-** IPv4 support
-** protocol version header
-** use strsep instead of strtok?
-
-* Pluginbasedclient
-** header files/symbols tally
-** check exit codes of all system calls
-** change uid to nobody:nogroup
-   other drop privs stuff?
-** pass things in environment, like device name, etc
-   Does cryptsetup already do this?
-** use strsep instead of strtok?
-
-* Server
-** config for:
-*** TXT record
-** protocol version header
-** Run-time communication with server
-   probably using D-Bus
-
-* Mandos-tools/utilities
-  All of this probably using D-Bus
-** List clients
-** Enable client
-** Disable client
-
-* Installer
-
-
-#+STARTUP: showall
+[Mandos client]
+configuration for OpenPGP key dir
+header files/symbols tally
+check exit codes of all system calls
+IPv4 support
+protocol version header
+use strsep instead of strtok?
+
+[Pluginbasedclient]
+disable certain plugins
+header files/symbols tally
+check exit codes of all system calls
+change uid to nobody:nogroup
+	other drop privs stuff?
+pass things in environment, like device name, etc
+	Does cryptsetup already do this?
+Configurable plugin dir
+use strsep instead of strtok?
+
+[Server]
+config for:
+	TXT record
+protocol version header
+Run-time communication with server
+	probably using D-Bus
+
+[Mandos-tools/utilities]
+	List clients
+	Enable client
+	Disable client
+
+[Installer]
+...

=== modified file 'plugbasedclient.c'
--- plugbasedclient.c	2008-08-02 15:47:42 +0000
+++ plugbasedclient.c	2008-07-29 03:35:39 +0000
@@ -21,34 +21,22 @@
  * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-
-#include <stdio.h>		/* popen(), fileno(), fprintf(),
-				   stderr, STDOUT_FILENO */
-#include <iso646.h>		/* and, or, not */
-#include <sys/types.h>	        /* DIR, opendir(), stat(),
-				   struct stat, waitpid(),
-				   WIFEXITED(), WEXITSTATUS(),
-				   wait() */
-#include <sys/wait.h>		/* wait() */
-#include <dirent.h>		/* DIR, struct dirent, opendir(),
-				   readdir(), closedir() */
-#include <sys/stat.h>		/* struct stat, stat(), S_ISREG() */
-#include <unistd.h>		/* struct stat, stat(), S_ISREG(),
-				   fcntl() */
-#include <fcntl.h>		/* fcntl() */
-#include <stddef.h>		/* NULL */
-#include <stdlib.h>		/* EXIT_FAILURE */
-#include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
-				   FD_SET(), FD_ISSET() */
-#include <string.h>		/* strlen(), strcpy(), strcat() */
-#include <stdbool.h>		/* true */
-#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
-				   WEXITSTATUS() */
-#include <errno.h>		/* errno */
-#include <argp.h>		/* struct argp_option,
-				   struct argp_state, struct argp,
-				   argp_parse() */
+#include <stdio.h>	/* popen, fileno */
+#include <iso646.h>	/* and, or, not */
+#include <sys/types.h>	/* DIR, opendir, stat, struct stat, waitpid,
+			   WIFEXITED, WEXITSTATUS, wait */
+#include <sys/wait.h>	/* wait */
+#include <dirent.h>	/* DIR, opendir */
+#include <sys/stat.h>	/* stat, struct stat */
+#include <unistd.h>	/* stat, struct stat, chdir */
+#include <stdlib.h>	/* EXIT_FAILURE */
+#include <sys/select.h>	/* fd_set, select, FD_ZERO, FD_SET,
+			   FD_ISSET */
+#include <string.h>	/* strlen, strcpy, strcat */
+#include <stdbool.h>	/* true */
+#include <sys/wait.h>	/* waitpid, WIFEXITED, WEXITSTATUS */
+#include <errno.h>	/* errno */
+#include <argp.h>	/* argp */
 
 struct process;
 
@@ -58,17 +46,13 @@
   char *buffer;
   size_t buffer_size;
   size_t buffer_length;
-  bool eof;
-  bool completed;
-  int status;
   struct process *next;
 } process;
 
 typedef struct plugin{
-  char *name;			/* can be NULL or any plugin name */
+  char *name; 		/* can be "global" and any plugin name */
   char **argv;
   int argc;
-  bool disabled;
   struct plugin *next;
 } plugin;
 
@@ -94,14 +78,13 @@
   new_plugin->argv[0] = name;
   new_plugin->argv[1] = NULL;
   new_plugin->argc = 1;
-  new_plugin->disabled = false;
+  /* Append the new plugin to the list */
   new_plugin->next = *plugin_list;
-  /* Append the new plugin to the list */
   *plugin_list = new_plugin;
   return new_plugin;
 }
 
-void addargument(plugin *p, char *arg){
+void addarguments(plugin *p, char *arg){
   p->argv[p->argc] = arg;
   p->argv = realloc(p->argv, sizeof(char *) * (size_t)(p->argc + 2));
   if (p->argv == NULL){
@@ -111,111 +94,49 @@
   p->argc++;
   p->argv[p->argc] = NULL;
 }
-
-/*
- * Based on the example in the GNU LibC manual chapter 13.13 "File
- * Descriptor Flags".
- * *Note File Descriptor Flags:(libc)Descriptor Flags.
- */
-int set_cloexec_flag(int fd)
-{
-  int ret = fcntl(fd, F_GETFD, 0);
-  /* If reading the flags failed, return error indication now. */
-  if(ret < 0){
-    return ret;
-  }
-  /* Store modified flag word in the descriptor. */
-  return fcntl(fd, F_SETFD, ret | FD_CLOEXEC);
-}
-
+	
 #define BUFFER_SIZE 256
 
-const char *argp_program_version = "plugbasedclient 0.9";
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
-
-process *process_list = NULL;
-
-/* Mark a process as completed when it exits, and save its exit
-   status. */
-void handle_sigchld(__attribute__((unused)) int sig){
-  process *proc = process_list;
-  int status;
-  pid_t pid = wait(&status);
-  while(proc != NULL and proc->pid != pid){
-    proc = proc->next;    
-  }
-  if(proc == NULL){
-    /* Process not found in process list */
-    return;
-  }
-  proc->status = status;
-  proc->completed = true;
-}
+const char *argp_program_version =
+  "plugbasedclient 0.9";
+const char *argp_program_bug_address =
+  "<mandos@fukt.bsnet.se>";
+static char doc[] =
+  "Mandos plugin runner -- Run Mandos plugins";
+/* A description of the arguments we accept. */
+static char args_doc[] = "";
 
 int main(int argc, char *argv[]){
-  const char *plugindir = "/conf/conf.d/mandos/plugins.d";
-  size_t d_name_len;
-  DIR *dir = NULL;
+  char plugindir[] = "plugins.d";
+  size_t d_name_len, plugindir_len = sizeof(plugindir)-1;
+  DIR *dir;
   struct dirent *dirst;
   struct stat st;
-  fd_set rfds_all;
+  fd_set rfds_orig;
   int ret, maxfd = 0;
-  uid_t uid = 65534;
-  gid_t gid = 65534;
-  bool debug = false;
-  int exitstatus = EXIT_SUCCESS;
-  struct sigaction old_sigchld_action;
-  struct sigaction sigchld_action = { .sa_handler = handle_sigchld,
-				      .sa_flags = SA_NOCLDSTOP };
-
-  /* Establish a signal handler */
-  sigemptyset(&sigchld_action.sa_mask);
-  ret = sigaddset(&sigchld_action.sa_mask, SIGCHLD);
-  if(ret < 0){
-    perror("sigaddset");
-    exit(EXIT_FAILURE);
-  }
-  ret = sigaction(SIGCHLD, &sigchld_action, &old_sigchld_action);
-  if(ret < 0){
-    perror("sigaction");
-    exit(EXIT_FAILURE);
-  }
+  process *process_list = NULL;
   
   /* The options we understand. */
   struct argp_option options[] = {
     { .name = "global-options", .key = 'g',
-      .arg = "OPTION[,OPTION[,...]]",
-      .doc = "Options passed to all plugins" },
+      .arg = "option[,option[,...]]", .flags = 0,
+      .doc = "Options effecting all plugins" },
     { .name = "options-for", .key = 'o',
-      .arg = "PLUGIN:OPTION[,OPTION[,...]]",
-      .doc = "Options passed only to specified plugin" },
-    { .name = "disable", .key = 'd',
-      .arg = "PLUGIN",
-      .doc = "Disable a specific plugin", .group = 1 },
-    { .name = "plugin-dir", .key = 128,
-      .arg = "DIRECTORY",
-      .doc = "Specify a different plugin directory", .group = 2 },
-    { .name = "userid", .key = 129,
-      .arg = "ID", .flags = 0,
-      .doc = "User ID the plugins will run as", .group = 2 },
-    { .name = "groupid", .key = 130,
-      .arg = "ID", .flags = 0,
-      .doc = "Group ID the plugins will run as", .group = 2 },
-    { .name = "debug", .key = 131,
-      .doc = "Debug mode", .group = 3 },
+      .arg = "plugin:option[,option[,...]]", .flags = 0,
+      .doc = "Options effecting only specified plugins" },
     { .name = NULL }
   };
   
   error_t parse_opt (int key, char *arg, struct argp_state *state) {
-    /* Get the INPUT argument from `argp_parse', which we know is a
-       pointer to our plugin list pointer. */
+       /* Get the INPUT argument from `argp_parse', which we
+          know is a pointer to our arguments structure. */
     plugin **plugins = state->input;
     switch (key) {
     case 'g':
       if (arg != NULL){
 	char *p = strtok(arg, ",");
 	do{
-	  addargument(getplugin(NULL, plugins), p);
+	  addarguments(getplugin(NULL, plugins), p);
 	  p = strtok(NULL, ",");
 	} while (p);
       }
@@ -224,31 +145,12 @@
       if (arg != NULL){
 	char *name = strtok(arg, ":");
 	char *p = strtok(NULL, ":");
-	if(p){
-	  p = strtok(p, ",");
-	  do{
-	    addargument(getplugin(name, plugins), p);
-	    p = strtok(NULL, ",");
-	  } while (p);
-	}
-      }
-      break;
-    case 'd':
-      if (arg != NULL){
-	getplugin(arg, plugins)->disabled = true;
-      }
-      break;
-    case 128:
-      plugindir = arg;
-      break;
-    case 129:
-      uid = (uid_t)strtol(arg, NULL, 10);
-      break;
-    case 130:
-      gid = (gid_t)strtol(arg, NULL, 10);
-      break;
-    case 131:
-      debug = true;
+	p = strtok(p, ",");
+	do{
+	  addarguments(getplugin(name, plugins), p);
+	  p = strtok(NULL, ",");
+	} while (p);
+      }
       break;
     case ARGP_KEY_ARG:
       argp_usage (state);
@@ -260,56 +162,31 @@
     }
     return 0;
   }
-  
+
   plugin *plugin_list = NULL;
   
   struct argp argp = { .options = options, .parser = parse_opt,
-		       .args_doc = "",
-		       .doc = "Mandos plugin runner -- Run plugins" };
-  
-  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);  
-
-  if(debug){
-    for(plugin *p = plugin_list; p != NULL; p=p->next){
-      fprintf(stderr, "Plugin: %s has %d arguments\n",
-	      p->name ? p->name : "Global", p->argc - 1);
-      for(char **a = p->argv; *a != NULL; a++){
-	fprintf(stderr, "\tArg: %s\n", *a);
-      }
-    }
-  }
-
-  ret = setuid(uid);
-  if (ret == -1){
-    perror("setuid");
-  }
-  
-  setgid(gid);
-  if (ret == -1){
-    perror("setuid");
-  }
+		       .args_doc = args_doc, .doc = doc };
+
+  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);
+
+/*   for(plugin *p = plugin_list; p != NULL; p=p->next){ */
+/*     fprintf(stderr, "Plugin: %s has %d arguments\n", p->name ? p->name : "Global", p->argc); */
+/*     for(char **a = p->argv + 1; *a != NULL; a++){ */
+/*       fprintf(stderr, "\tArg: %s\n", *a); */
+/*     } */
+/*   } */
+  
+/*   return 0; */
   
   dir = opendir(plugindir);
+  
   if(dir == NULL){
-    perror("Could not open plugin dir");
-    exitstatus = EXIT_FAILURE;
-    goto end;
-  }
-  
-  /* Set the FD_CLOEXEC flag on the directory, if possible */
-  {
-    int dir_fd = dirfd(dir);
-    if(dir_fd >= 0){
-      ret = set_cloexec_flag(dir_fd);
-      if(ret < 0){
-	perror("set_cloexec_flag");
-	exitstatus = EXIT_FAILURE;
-	goto end;
-      }
-    }
-  }
-  
-  FD_ZERO(&rfds_all);
+    fprintf(stderr, "Can not open directory\n");
+    return EXIT_FAILURE;
+  }
+  
+  FD_ZERO(&rfds_orig);
   
   while(true){
     dirst = readdir(dir);
@@ -321,336 +198,151 @@
     
     d_name_len = strlen(dirst->d_name);
     
-    // Ignore dotfiles, backup files and other junk
-    {
-      bool bad_name = false;
-      
-      const char const *bad_prefixes[] = { ".", "#", NULL };
-      
-      const char const *bad_suffixes[] = { "~", "#", ".dpkg-new",
-					   ".dpkg-old",
-					   ".dpkg-divert", NULL };
-      for(const char **pre = bad_prefixes; *pre != NULL; pre++){
-	size_t pre_len = strlen(*pre);
-	if((d_name_len >= pre_len)
-	   and strncmp((dirst->d_name), *pre, pre_len) == 0){
-	  if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " with bad prefix %s\n", dirst->d_name, *pre);
-	  }
-	  bad_name = true;
-	  break;
-	}
-      }
-      
-      if(bad_name){
-	continue;
-      }
-      
-      for(const char **suf = bad_suffixes; *suf != NULL; suf++){
-	size_t suf_len = strlen(*suf);
-	if((d_name_len >= suf_len)
-	   and (strcmp((dirst->d_name)+d_name_len-suf_len, *suf)
-		== 0)){
-	  if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " with bad suffix %s\n", dirst->d_name, *suf);
-	  }
-	  bad_name = true;
-	  break;
-	}
-      }
-      
-      if(bad_name){
-	continue;
-      }
-    }
-    
-    char *filename = malloc(d_name_len + strlen(plugindir) + 2);
-    if (filename == NULL){
-      perror("malloc");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    strcpy(filename, plugindir); /* Spurious warning */
-    strcat(filename, "/");	/* Spurious warning */
-    strcat(filename, dirst->d_name); /* Spurious warning */
-    
+    // Ignore dotfiles and backup files
+    if (dirst->d_name[0] == '.'
+	or dirst->d_name[d_name_len - 1] == '~'){
+      continue;
+    }
+
+    char *filename = malloc(d_name_len + plugindir_len + 2);
+    strcpy(filename, plugindir);
+    strcat(filename, "/");
+    strcat(filename, dirst->d_name);    
+
     stat(filename, &st);
-    
-    if (not S_ISREG(st.st_mode)	or (access(filename, X_OK) != 0)){
-      if(debug){
-	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		" with bad type or mode\n", filename);
-      }
-      free(filename);
-      continue;
-    }
-    if(getplugin(dirst->d_name, &plugin_list)->disabled){
-      if(debug){
-	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
-		dirst->d_name);
-      }
-      free(filename);
-      continue;
-    }
-    plugin *p = getplugin(dirst->d_name, &plugin_list);
-    {
-      /* Add global arguments to argument list for this plugin */
-      plugin *g = getplugin(NULL, &plugin_list);
-      for(char **a = g->argv + 1; *a != NULL; a++){
-	addargument(p, *a);
-      }
-    }
-    int pipefd[2]; 
-    ret = pipe(pipefd);
-    if (ret == -1){
-      perror("pipe");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    ret = set_cloexec_flag(pipefd[0]);
-    if(ret < 0){
-      perror("set_cloexec_flag");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    ret = set_cloexec_flag(pipefd[1]);
-    if(ret < 0){
-      perror("set_cloexec_flag");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    /* Block SIGCHLD until process is safely in process list */
-    ret = sigprocmask (SIG_BLOCK, &sigchld_action.sa_mask, NULL);
-    if(ret < 0){
-      perror("sigprocmask");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    // Starting a new process to be watched
-    pid_t pid = fork();
-    if(pid == 0){
-      /* this is the child process */
-      ret = sigaction(SIGCHLD, &old_sigchld_action, NULL);
-      if(ret < 0){
-	perror("sigaction");
-	_exit(EXIT_FAILURE);
-      }
-      ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
-      if(ret < 0){
-	perror("sigprocmask");
-	_exit(EXIT_FAILURE);
-      }
-      dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
-      
-      if(dirfd(dir) < 0){
-	/* If dir has no file descriptor, we could not set FD_CLOEXEC
-	   above and must now close it manually here. */
+
+    if (S_ISREG(st.st_mode) and (access(filename, X_OK) == 0)){
+      // Starting a new process to be watched
+      process *new_process = malloc(sizeof(process));
+      int pipefd[2];
+      ret = pipe(pipefd);
+      if (ret == -1){
+	perror(argv[0]);
+	goto end;
+      }
+      new_process->pid = fork();
+      if(new_process->pid == 0){
+	/* this is the child process */
 	closedir(dir);
-      }
-      if(execv(filename, p->argv) < 0){
-	perror("execv");
-	_exit(EXIT_FAILURE);
-      }
-      /* no return */
-    }
-    /* parent process */
-    free(filename);
-    close(pipefd[1]);		/* close unused write end of pipe */
-    process *new_process = malloc(sizeof(process));
-    if (new_process == NULL){
-      perror("malloc");
-      ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
-      if(ret < 0){
-	perror("sigprocmask");
-      }
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    
-    *new_process = (struct process){ .pid = pid,
-				     .fd = pipefd[0],
-				     .next = process_list };
-    // List handling
-    process_list = new_process;
-    /* Unblock SIGCHLD so signal handler can be run if this process
-       has already completed */
-    ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
-    if(ret < 0){
-      perror("sigprocmask");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    
-    FD_SET(new_process->fd, &rfds_all);
-    
-    if (maxfd < new_process->fd){
-      maxfd = new_process->fd;
-    }
-    
-  }
-  
-  /* Free the plugin list */
-  for(plugin *next; plugin_list != NULL; plugin_list = next){
-    next = plugin_list->next;
-    free(plugin_list->argv);
-    free(plugin_list);
+	close(pipefd[0]);	/* close unused read end of pipe */
+	dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
+	char *basename;
+	basename = strrchr(filename, '/');
+	if (basename == NULL){
+	  basename = filename;
+	} else {
+	  basename++;
+	}
+	plugin *p = getplugin(basename, &plugin_list);
+
+	plugin *g = getplugin(NULL, &plugin_list);
+	for(char **a = g->argv + 1; *a != NULL; a++){
+	  addarguments(p, *a);
+	}
+	if(execv(filename, p->argv) < 0){
+	  perror(argv[0]);
+	  close(pipefd[1]);
+	  exit(EXIT_FAILURE);
+	}
+	/* no return */
+      }
+      close(pipefd[1]);		/* close unused write end of pipe */
+      new_process->fd = pipefd[0];
+      new_process->buffer = malloc(BUFFER_SIZE);
+      if (new_process->buffer == NULL){
+	perror(argv[0]);
+	goto end;
+      }
+      new_process->buffer_size = BUFFER_SIZE;
+      new_process->buffer_length = 0;
+      FD_SET(new_process->fd, &rfds_orig);
+      
+      if (maxfd < new_process->fd){
+	maxfd = new_process->fd;
+      }
+      
+      //List handling
+      new_process->next = process_list;
+      process_list = new_process;
+    }
   }
   
   closedir(dir);
-  dir = NULL;
   
-  if (process_list == NULL){
-    fprintf(stderr, "No plugin processes started, exiting\n");
-    exitstatus = EXIT_FAILURE;
-    goto end;
-  }
-  while(process_list){
-    fd_set rfds = rfds_all;
-    int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
-    if (select_ret == -1){
-      perror("select");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    /* OK, now either a process completed, or something can be read
-       from one of them */
-    for(process *proc = process_list; proc ; proc = proc->next){
-      /* Is this process completely done? */
-      if(proc->eof and proc->completed){
-	/* Only accept the plugin output if it exited cleanly */
-	if(not WIFEXITED(proc->status)
-	   or WEXITSTATUS(proc->status) != 0){
-	  /* Bad exit by plugin */
-	  if(debug){
-	    if(WIFEXITED(proc->status)){
-	      fprintf(stderr, "Plugin %d exited with status %d\n",
-		      proc->pid, WEXITSTATUS(proc->status));
-	    } else if(WIFSIGNALED(proc->status)) {
-	      fprintf(stderr, "Plugin %d killed by signal %d\n",
-		      proc->pid, WTERMSIG(proc->status));
-	    } else if(WCOREDUMP(proc->status)){
-	      fprintf(stderr, "Plugin %d dumped core\n", proc->pid);
-	    }
-	  }
-	  /* Remove the plugin */
-	  FD_CLR(proc->fd, &rfds_all);
-	  /* Block signal while modifying process_list */
-	  ret = sigprocmask (SIG_BLOCK, &sigchld_action.sa_mask, NULL);
-	  if(ret < 0){
-	    perror("sigprocmask");
-	    exitstatus = EXIT_FAILURE;
-	    goto end;
-	  }
-	  /* Delete this process entry from the list */
-	  if(process_list == proc){
-	    /* First one - simple */
-	    process_list = proc->next;
-	  } else {
-	    /* Second one or later */
-	    for(process *p = process_list; p != NULL; p = p->next){
-	      if(p->next == proc){
-		p->next = proc->next;
-		break;
+  if (process_list != NULL){
+    while(true){
+      fd_set rfds = rfds_orig;
+      int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
+      if (select_ret == -1){
+	perror(argv[0]);
+	goto end;
+      }else{	
+	for(process *process_itr = process_list; process_itr != NULL;
+	    process_itr = process_itr->next){
+	  if(FD_ISSET(process_itr->fd, &rfds)){
+	    if(process_itr->buffer_length + BUFFER_SIZE
+	       > process_itr->buffer_size){
+		process_itr->buffer = realloc(process_itr->buffer,
+					      process_itr->buffer_size
+					      + (size_t) BUFFER_SIZE);
+		if (process_itr->buffer == NULL){
+		  perror(argv[0]);
+		  goto end;
+		}
+		process_itr->buffer_size += BUFFER_SIZE;
+	    }
+	    ret = read(process_itr->fd, process_itr->buffer
+		       + process_itr->buffer_length, BUFFER_SIZE);
+	    if(ret < 0){
+	      /* Read error from this process; ignore it */
+	      continue;
+	    }
+	    process_itr->buffer_length += (size_t) ret;
+	    if(ret == 0){
+	      /* got EOF */
+	      /* wait for process exit */
+	      int status;
+	      waitpid(process_itr->pid, &status, 0);
+	      if(WIFEXITED(status) and WEXITSTATUS(status) == 0){
+		for(size_t written = 0;
+		    written < process_itr->buffer_length;){
+		  ret = write(STDOUT_FILENO,
+			      process_itr->buffer + written,
+			      process_itr->buffer_length - written);
+		  if(ret < 0){
+		    perror(argv[0]);
+		    goto end;
+		  }
+		  written += (size_t)ret;
+		}
+		goto end;
+	      } else {
+		FD_CLR(process_itr->fd, &rfds_orig);
 	      }
 	    }
 	  }
-	  /* We are done modifying process list, so unblock signal */
-	  ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask,
-			     NULL);
-	  if(ret < 0){
-	    perror("sigprocmask");
-	  }
-	  free(proc->buffer);
-	  free(proc);
-	  /* We deleted this process from the list, so we can't go
-	     proc->next.  Therefore, start over from the beginning of
-	     the process list */
-	  break;
-	}
-	/* This process exited nicely, so print its buffer */
-	for(size_t written = 0; written < proc->buffer_length;
-	    written += (size_t)ret){
-	  ret = TEMP_FAILURE_RETRY(write(STDOUT_FILENO,
-					 proc->buffer + written,
-					 proc->buffer_length
-					 - written));
-	  if(ret < 0){
-	    perror("write");
-	    exitstatus = EXIT_FAILURE;
-	    goto end;
-	  }
-	}
-	goto end;
-      }
-      /* This process has not completed.  Does it have any output? */
-      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){
-	/* This process had nothing to say at this time */
-	continue;
-      }
-      /* Before reading, make the process' data buffer large enough */
-      if(proc->buffer_length + BUFFER_SIZE > proc->buffer_size){
-	proc->buffer = realloc(proc->buffer, proc->buffer_size
-			       + (size_t) BUFFER_SIZE);
-	if (proc->buffer == NULL){
-	  perror("malloc");
-	  exitstatus = EXIT_FAILURE;
-	  goto end;
-	}
-	proc->buffer_size += BUFFER_SIZE;
-      }
-      /* Read from the process */
-      ret = read(proc->fd, proc->buffer + proc->buffer_length,
-		 BUFFER_SIZE);
-      if(ret < 0){
-	/* Read error from this process; ignore the error */
-	continue;
-      }
-      if(ret == 0){
-	/* got EOF */
-	proc->eof = true;
-      } else {
-	proc->buffer_length += (size_t) ret;
+	}
       }
     }
   }
-  if(process_list == NULL){
-    fprintf(stderr, "All plugin processes failed, exiting\n");
-    exitstatus = EXIT_FAILURE;
-  }
   
  end:
-  /* Restore old signal handler */
-  sigaction(SIGCHLD, &old_sigchld_action, NULL);
-  
-  /* Free the plugin list */
-  for(plugin *next; plugin_list != NULL; plugin_list = next){
-    next = plugin_list->next;
-    free(plugin_list->argv);
-    free(plugin_list);
-  }
-  
-  if(dir != NULL){
-    closedir(dir);
-  }
-  
-  /* Free the process list and kill the processes */
-  for(process *next; process_list != NULL; process_list = next){
-    next = process_list->next;
-    close(process_list->fd);
-    kill(process_list->pid, SIGTERM);
-    free(process_list->buffer);
-    free(process_list);
-  }
-  
-  /* Wait for any remaining child processes to terminate */
-  do{
-    ret = wait(NULL);
-  } while(ret >= 0);
-  if(errno != ECHILD){
-    perror("wait");
-  }
-  
-  return exitstatus;
+  for(process *process_itr = process_list; process_itr != NULL;
+      process_itr = process_itr->next){
+    close(process_itr->fd);
+    kill(process_itr->pid, SIGTERM);
+    free(process_itr->buffer);
+  }
+  
+  while(true){
+    int status;
+    ret = wait(&status);
+    if (ret == -1){
+      if(errno != ECHILD){
+	perror("wait");
+      }
+      break;
+    }
+  }  
+  return EXIT_SUCCESS;
 }

=== modified file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-08-02 15:47:42 +0000
+++ plugins.d/mandosclient.c	2008-07-29 03:35:39 +0000
@@ -25,7 +25,8 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
+ * <https://www.fukt.bsnet.se/~teddy/>.
  */
 
 /* Needed by GPGME, specifically gpgme_data_seek() */
@@ -37,8 +38,6 @@
 #include <stdlib.h>
 #include <time.h>
 #include <net/if.h>		/* if_nametoindex */
-#include <sys/ioctl.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
-#include <net/if.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
 
 #include <avahi-core/core.h>
 #include <avahi-core/lookup.h>
@@ -68,13 +67,14 @@
 // getopt long
 #include <getopt.h>
 
+#ifndef CERT_ROOT
+#define CERT_ROOT "/conf/conf.d/cryptkeyreq/"
+#endif
+#define CERTFILE CERT_ROOT "openpgp-client.txt"
+#define KEYFILE CERT_ROOT "openpgp-client-key.txt"
 #define BUFFER_SIZE 256
 #define DH_BITS 1024
 
-static const char *certdir = "/conf/conf.d/mandos";
-static const char *certfile = "openpgp-client.txt";
-static const char *certkey = "openpgp-client-key.txt";
-
 bool debug = false;
 
 typedef struct {
@@ -84,9 +84,8 @@
 } encrypted_session;
 
 
-static ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
-				   char **new_packet,
-				   const char *homedir){
+ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
+			    char **new_packet, const char *homedir){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_ctx_t ctx;
   gpgme_error_t rc;
@@ -101,12 +100,7 @@
   
   /* Init GPGME */
   gpgme_check_version(NULL);
-  rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return -1;
-  }
+  gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   
   /* Set GPGME home directory */
   rc = gpgme_get_engine_info (&engine_info);
@@ -198,10 +192,8 @@
   gpgme_data_release(dh_crypto);
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
-  if (gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET) == -1){
-    perror("pgpme_data_seek");
-  }
-  
+  gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET);
+
   *new_packet = 0;
   while(true){
     if (new_packet_length + BUFFER_SIZE > new_packet_capacity){
@@ -248,19 +240,19 @@
   return ret;
 }
 
-static void debuggnutls(__attribute__((unused)) int level,
-			const char* string){
+void debuggnutls(__attribute__((unused)) int level,
+		 const char* string){
   fprintf(stderr, "%s", string);
 }
 
-static int initgnutls(encrypted_session *es){
+int initgnutls(encrypted_session *es){
   const char *err;
   int ret;
   
   if(debug){
     fprintf(stderr, "Initializing GnuTLS\n");
   }
-
+  
   if ((ret = gnutls_global_init ())
       != GNUTLS_E_SUCCESS) {
     fprintf (stderr, "global_init: %s\n", safer_gnutls_strerror(ret));
@@ -282,17 +274,17 @@
   
   if(debug){
     fprintf(stderr, "Attempting to use OpenPGP certificate %s"
-	    " and keyfile %s as GnuTLS credentials\n", certfile,
-	    certkey);
+	    " and keyfile %s as GnuTLS credentials\n", CERTFILE,
+	    KEYFILE);
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
-    (es->cred, certfile, certkey, GNUTLS_OPENPGP_FMT_BASE64);
+    (es->cred, CERTFILE, KEYFILE, GNUTLS_OPENPGP_FMT_BASE64);
   if (ret != GNUTLS_E_SUCCESS) {
     fprintf
       (stderr, "Error[%d] while reading the OpenPGP key pair ('%s',"
        " '%s')\n",
-       ret, certfile, certkey);
+       ret, CERTFILE, KEYFILE);
     fprintf(stdout, "The Error is: %s\n",
 	    safer_gnutls_strerror(ret));
     return -1;
@@ -347,11 +339,11 @@
   return 0;
 }
 
-static void empty_log(__attribute__((unused)) AvahiLogLevel level,
-		      __attribute__((unused)) const char *txt){}
+void empty_log(__attribute__((unused)) AvahiLogLevel level,
+	       __attribute__((unused)) const char *txt){}
 
-static int start_mandos_communication(const char *ip, uint16_t port,
-				      AvahiIfIndex if_index){
+int start_mandos_communication(const char *ip, uint16_t port,
+			       unsigned int if_index){
   int ret, tcp_sd;
   struct sockaddr_in6 to;
   encrypted_session es;
@@ -374,15 +366,15 @@
     perror("socket");
     return -1;
   }
-
+  
+  if(if_indextoname(if_index, interface) == NULL){
+    if(debug){
+      perror("if_indextoname");
+    }
+    return -1;
+  }
+  
   if(debug){
-    if(if_indextoname((unsigned int)if_index, interface) == NULL){
-      if(debug){
-	perror("if_indextoname");
-      }
-      return -1;
-    }
-    
     fprintf(stderr, "Binding to interface %s\n", interface);
   }
   
@@ -495,7 +487,7 @@
     decrypted_buffer_size = pgp_packet_decrypt(buffer,
 					       buffer_length,
 					       &decrypted_buffer,
-					       certdir);
+					       CERT_ROOT);
     if (decrypted_buffer_size >= 0){
       while(written < (size_t) decrypted_buffer_size){
 	ret = (int)fwrite (decrypted_buffer + written, 1,
@@ -572,7 +564,8 @@
 	fprintf(stderr, "Mandos server \"%s\" found on %s (%s) on"
 		" port %d\n", name, host_name, ip, port);
       }
-      int ret = start_mandos_communication(ip, port, interface);
+      int ret = start_mandos_communication(ip, port,
+					   (unsigned int) interface);
       if (ret == 0){
 	exit(EXIT_SUCCESS);
       }
@@ -630,27 +623,6 @@
     }
 }
 
-/* Combines file name and path and returns the malloced new
-   string. some sane checks could/should be added */
-static const char *combinepath(const char *first, const char *second){
-  size_t f_len = strlen(first);
-  size_t s_len = strlen(second);
-  char *tmp = malloc(f_len + s_len + 2);
-  if (tmp == NULL){
-    return NULL;
-  }
-  if(f_len > 0){
-    memcpy(tmp, first, f_len);
-  }
-  tmp[f_len] = '/';
-  if(s_len > 0){
-    memcpy(tmp + f_len + 1, second, s_len);
-  }
-  tmp[f_len + 1 + s_len] = '\0';
-  return tmp;
-}
-
-
 int main(AVAHI_GCC_UNUSED int argc, AVAHI_GCC_UNUSED char*argv[]) {
     AvahiServerConfig config;
     AvahiSServiceBrowser *sb = NULL;
@@ -658,19 +630,14 @@
     int ret;
     int returncode = EXIT_SUCCESS;
     const char *interface = "eth0";
-    struct ifreq network;
-    int sd;
+    unsigned int if_index;
     char *connect_to = NULL;
-    AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
     
     while (true){
       static struct option long_options[] = {
 	{"debug", no_argument, (int *)&debug, 1},
-	{"connect", required_argument, 0, 'C'},
+	{"connect", required_argument, 0, 'c'},
 	{"interface", required_argument, 0, 'i'},
-	{"certdir", required_argument, 0, 'd'},
-	{"certkey", required_argument, 0, 'c'},
-	{"certfile", required_argument, 0, 'k'},
 	{0, 0, 0, 0} };
       
       int option_index = 0;
@@ -687,38 +654,15 @@
       case 'i':
 	interface = optarg;
 	break;
-      case 'C':
+      case 'c':
 	connect_to = optarg;
 	break;
-      case 'd':
-	certdir = optarg;
-	break;
-      case 'c':
-	certfile = optarg;
-	break;
-      case 'k':
-	certkey = optarg;
-	break;
       default:
 	exit(EXIT_FAILURE);
       }
     }
     
-    certfile = combinepath(certdir, certfile);
-    if (certfile == NULL){
-      perror("combinepath");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-
-    certkey = combinepath(certdir, certkey);
-    if (certkey == NULL){
-      perror("combinepath");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    
-    if_index = (AvahiIfIndex) if_nametoindex(interface);
+    if_index = if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
       exit(EXIT_FAILURE);
@@ -748,31 +692,6 @@
       }
     }
     
-    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd < 0) {
-      perror("socket");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    strcpy(network.ifr_name, interface);    
-    ret = ioctl(sd, SIOCGIFFLAGS, &network);
-    if(ret == -1){
-      
-      perror("ioctl SIOCGIFFLAGS");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    if((network.ifr_flags & IFF_UP) == 0){
-      network.ifr_flags |= IFF_UP;
-      ret = ioctl(sd, SIOCSIFFLAGS, &network);
-      if(ret == -1){
-	perror("ioctl SIOCSIFFLAGS");
-	returncode = EXIT_FAILURE;
-	goto exit;
-      }
-    }
-    close(sd);
-    
     if (not debug){
       avahi_set_log_function(empty_log);
     }
@@ -783,7 +702,7 @@
     /* Allocate main loop object */
     if (!(simple_poll = avahi_simple_poll_new())) {
         fprintf(stderr, "Failed to create simple poll object.\n");
-	returncode = EXIT_FAILURE;	
+	
         goto exit;
     }
 
@@ -810,7 +729,7 @@
     }
     
     /* Create the service browser */
-    sb = avahi_s_service_browser_new(server, if_index,
+    sb = avahi_s_service_browser_new(server, (AvahiIfIndex)if_index,
 				     AVAHI_PROTO_INET6,
 				     "_mandos._tcp", NULL, 0,
 				     browse_callback, server);
@@ -844,8 +763,6 @@
 
     if (simple_poll)
         avahi_simple_poll_free(simple_poll);
-    free(certfile);
-    free(certkey);
-    
+
     return returncode;
 }

=== modified file 'plugins.d/passprompt.c'
--- plugins.d/passprompt.c	2008-08-02 10:48:24 +0000
+++ plugins.d/passprompt.c	2008-07-29 03:35:39 +0000
@@ -102,11 +102,15 @@
   
   sigemptyset(&new_action.sa_mask);
   sigaddset(&new_action.sa_mask, SIGINT);
+  sigaddset(&new_action.sa_mask, SIGQUIT);
   sigaddset(&new_action.sa_mask, SIGHUP);
   sigaddset(&new_action.sa_mask, SIGTERM);
   sigaction(SIGINT, NULL, &old_action);
   if (old_action.sa_handler != SIG_IGN)
     sigaction(SIGINT, &new_action, NULL);
+  sigaction(SIGQUIT, NULL, &old_action);
+  if (old_action.sa_handler != SIG_IGN)
+    sigaction(SIGQUIT, &new_action, NULL);
   sigaction(SIGHUP, NULL, &old_action);
   if (old_action.sa_handler != SIG_IGN)
     sigaction(SIGHUP, &new_action, NULL);

=== modified file 'server.py'
--- server.py	2008-07-31 19:48:05 +0000
+++ server.py	2008-07-29 03:35:39 +0000
@@ -509,7 +509,7 @@
         """This overrides the normal server_bind() function
         to bind to an interface if one was specified, and also NOT to
         bind to an address or port if they were not specified."""
-        if self.settings["interface"]:
+        if self.settings["interface"] != avahi.IF_UNSPEC:
             # 25 is from /usr/include/asm-i486/socket.h
             SO_BINDTODEVICE = getattr(socket, "SO_BINDTODEVICE", 25)
             try:
@@ -603,7 +603,7 @@
             try:
                 libc = ctypes.cdll.LoadLibrary\
                        (ctypes.util.find_library("c"))
-                _func[0] = libc.if_nametoindex
+                func[0] = libc.if_nametoindex
                 return _func[0](interface)
             except IOError, e:
                 if e != errno.EINTR:
@@ -699,6 +699,8 @@
     server_settings["debug"] = server_config.getboolean\
                                (server_section, "debug")
     del server_config
+    if not server_settings["interface"]:
+        server_settings["interface"] = avahi.IF_UNSPEC
     
     # Override the settings from the config file with command line
     # options, if set.
@@ -722,8 +724,6 @@
     global service
     service = AvahiService(name = server_settings["servicename"],
                            type = "_mandos._tcp", );
-    if server_settings["interface"]:
-        service.interface = if_nametoindex(server_settings["interface"])
     
     global main_loop
     global bus
@@ -794,10 +794,11 @@
                                 clients=clients)
     # Find out what port we got
     service.port = tcp_server.socket.getsockname()[1]
-    logger.debug(u"Now listening on address %r, port %d, flowinfo %d,"
-                 u" scope_id %d" % tcp_server.socket.getsockname())
+    logger.debug(u"Now listening on port %d", service.port)
     
-    #service.interface = tcp_server.socket.getsockname()[3]
+    if not server_settings["interface"]:
+        service.interface = if_nametoindex\
+                            (server_settings["interface"])
     
     try:
         # From the Avahi example code

